/* The following code was generated by JFlex 1.6.1 */

package pasito.syntax;

import java_cup.runtime.ComplexSymbolFactory.Location;
import java_cup.runtime.ComplexSymbolFactory;
import java.io.IOException;
import java_cup.runtime.Symbol;
import java.io.FileInputStream;
import org.apache.commons.math3.complex.ComplexFormat;


/**
 * This class is a scanner generated by 
 * <a href="http://www.jflex.de/">JFlex</a> 1.6.1
 * from the specification file <tt>/home/gabriel/Workspaces/PasitoCompilador/Pasito.jflex</tt>
 */
public class LexicalAnalyzer implements java_cup.runtime.Scanner, sym {

  /** This character denotes the end of file */
  public static final int YYEOF = -1;

  /** initial size of the lookahead buffer */
  private static final int ZZ_BUFFERSIZE = 16384;
  private static final String ZZ_NL = System.getProperty("line.separator");

  /** lexical states */
  public static final int YYINITIAL = 0;
  public static final int INTERPRETED_STRING = 2;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = { 
     0,  0,  1, 1
  };

  /** 
   * Translates characters to character classes
   */
  private static final String ZZ_CMAP_PACKED = 
    "\11\0\1\7\1\3\1\5\1\6\1\4\22\0\1\7\1\75\1\42"+
    "\2\0\1\66\1\67\1\27\1\77\1\103\1\2\1\23\1\102\1\24"+
    "\1\25\1\1\1\13\1\16\1\46\1\45\1\50\1\16\1\47\1\16"+
    "\2\12\1\76\1\106\1\72\1\74\1\73\2\0\1\56\1\14\1\54"+
    "\1\14\1\22\1\14\1\10\1\55\5\10\1\57\6\10\1\32\2\10"+
    "\1\20\2\10\1\100\1\30\1\104\1\71\1\10\1\107\1\33\1\34"+
    "\1\52\1\15\1\21\1\35\1\61\1\60\1\26\1\10\1\51\1\44"+
    "\1\62\1\36\1\43\1\63\1\10\1\37\1\53\1\40\1\31\1\41"+
    "\1\64\1\17\1\65\1\10\1\101\1\70\1\105\7\0\1\5\44\0"+
    "\1\10\12\0\1\10\4\0\1\10\5\0\27\10\1\0\37\10\1\0"+
    "\u01ca\10\4\0\14\10\16\0\5\10\7\0\1\10\1\0\1\10\201\0"+
    "\5\10\1\0\2\10\2\0\4\10\1\0\1\10\6\0\1\10\1\0"+
    "\3\10\1\0\1\10\1\0\24\10\1\0\123\10\1\0\213\10\10\0"+
    "\246\10\1\0\46\10\2\0\1\10\7\0\47\10\110\0\33\10\5\0"+
    "\3\10\55\0\53\10\25\0\12\11\4\0\2\10\1\0\143\10\1\0"+
    "\1\10\17\0\2\10\7\0\2\10\12\11\3\10\2\0\1\10\20\0"+
    "\1\10\1\0\36\10\35\0\131\10\13\0\1\10\16\0\12\11\41\10"+
    "\11\0\2\10\4\0\1\10\5\0\26\10\4\0\1\10\11\0\1\10"+
    "\3\0\1\10\27\0\31\10\107\0\23\10\121\0\66\10\3\0\1\10"+
    "\22\0\1\10\7\0\12\10\4\0\12\11\1\0\20\10\4\0\10\10"+
    "\2\0\2\10\2\0\26\10\1\0\7\10\1\0\1\10\3\0\4\10"+
    "\3\0\1\10\20\0\1\10\15\0\2\10\1\0\3\10\4\0\12\11"+
    "\2\10\23\0\6\10\4\0\2\10\2\0\26\10\1\0\7\10\1\0"+
    "\2\10\1\0\2\10\1\0\2\10\37\0\4\10\1\0\1\10\7\0"+
    "\12\11\2\0\3\10\20\0\11\10\1\0\3\10\1\0\26\10\1\0"+
    "\7\10\1\0\2\10\1\0\5\10\3\0\1\10\22\0\1\10\17\0"+
    "\2\10\4\0\12\11\25\0\10\10\2\0\2\10\2\0\26\10\1\0"+
    "\7\10\1\0\2\10\1\0\5\10\3\0\1\10\36\0\2\10\1\0"+
    "\3\10\4\0\12\11\1\0\1\10\21\0\1\10\1\0\6\10\3\0"+
    "\3\10\1\0\4\10\3\0\2\10\1\0\1\10\1\0\2\10\3\0"+
    "\2\10\3\0\3\10\3\0\14\10\26\0\1\10\25\0\12\11\25\0"+
    "\10\10\1\0\3\10\1\0\27\10\1\0\20\10\3\0\1\10\32\0"+
    "\2\10\6\0\2\10\4\0\12\11\25\0\10\10\1\0\3\10\1\0"+
    "\27\10\1\0\12\10\1\0\5\10\3\0\1\10\40\0\1\10\1\0"+
    "\2\10\4\0\12\11\1\0\2\10\22\0\10\10\1\0\3\10\1\0"+
    "\51\10\2\0\1\10\20\0\1\10\21\0\2\10\4\0\12\11\12\0"+
    "\6\10\5\0\22\10\3\0\30\10\1\0\11\10\1\0\1\10\2\0"+
    "\7\10\37\0\12\11\21\0\60\10\1\0\2\10\14\0\7\10\11\0"+
    "\12\11\47\0\2\10\1\0\1\10\2\0\2\10\1\0\1\10\2\0"+
    "\1\10\6\0\4\10\1\0\7\10\1\0\3\10\1\0\1\10\1\0"+
    "\1\10\2\0\2\10\1\0\4\10\1\0\2\10\11\0\1\10\2\0"+
    "\5\10\1\0\1\10\11\0\12\11\2\0\4\10\40\0\1\10\37\0"+
    "\12\11\26\0\10\10\1\0\44\10\33\0\5\10\163\0\53\10\24\0"+
    "\1\10\12\11\6\0\6\10\4\0\4\10\3\0\1\10\3\0\2\10"+
    "\7\0\3\10\4\0\15\10\14\0\1\10\1\0\12\11\6\0\46\10"+
    "\1\0\1\10\5\0\1\10\2\0\53\10\1\0\u014d\10\1\0\4\10"+
    "\2\0\7\10\1\0\1\10\1\0\4\10\2\0\51\10\1\0\4\10"+
    "\2\0\41\10\1\0\4\10\2\0\7\10\1\0\1\10\1\0\4\10"+
    "\2\0\17\10\1\0\71\10\1\0\4\10\2\0\103\10\45\0\20\10"+
    "\20\0\125\10\14\0\u026c\10\2\0\21\10\1\0\32\10\5\0\113\10"+
    "\6\0\10\10\7\0\15\10\1\0\4\10\16\0\22\10\16\0\22\10"+
    "\16\0\15\10\1\0\3\10\17\0\64\10\43\0\1\10\4\0\1\10"+
    "\3\0\12\11\46\0\12\11\6\0\130\10\10\0\51\10\1\0\1\10"+
    "\5\0\106\10\12\0\37\10\47\0\12\11\36\10\2\0\5\10\13\0"+
    "\54\10\25\0\7\10\10\0\12\11\46\0\27\10\11\0\65\10\53\0"+
    "\12\11\6\0\12\11\15\0\1\10\135\0\57\10\21\0\7\10\4\0"+
    "\12\11\51\0\36\10\15\0\2\10\12\11\54\10\32\0\44\10\34\0"+
    "\12\11\3\0\3\10\12\11\44\10\153\0\4\10\1\0\4\10\3\0"+
    "\2\10\11\0\300\10\100\0\u0116\10\2\0\6\10\2\0\46\10\2\0"+
    "\6\10\2\0\10\10\1\0\1\10\1\0\1\10\1\0\1\10\1\0"+
    "\37\10\2\0\65\10\1\0\7\10\1\0\1\10\3\0\3\10\1\0"+
    "\7\10\3\0\4\10\2\0\6\10\4\0\15\10\5\0\3\10\1\0"+
    "\7\10\53\0\1\5\1\5\107\0\1\10\15\0\1\10\20\0\15\10"+
    "\145\0\1\10\4\0\1\10\2\0\12\10\1\0\1\10\3\0\5\10"+
    "\6\0\1\10\1\0\1\10\1\0\1\10\1\0\4\10\1\0\13\10"+
    "\2\0\4\10\5\0\5\10\4\0\1\10\64\0\2\10\u0a7b\0\57\10"+
    "\1\0\57\10\1\0\205\10\6\0\4\10\3\0\2\10\14\0\46\10"+
    "\1\0\1\10\5\0\1\10\2\0\70\10\7\0\1\10\20\0\27\10"+
    "\11\0\7\10\1\0\7\10\1\0\7\10\1\0\7\10\1\0\7\10"+
    "\1\0\7\10\1\0\7\10\1\0\7\10\120\0\1\10\u01d5\0\2\10"+
    "\52\0\5\10\5\0\2\10\4\0\126\10\6\0\3\10\1\0\132\10"+
    "\1\0\4\10\5\0\51\10\3\0\136\10\21\0\33\10\65\0\20\10"+
    "\u0200\0\u19b6\10\112\0\u51cd\10\63\0\u048d\10\103\0\56\10\2\0\u010d\10"+
    "\3\0\20\10\12\11\2\10\24\0\57\10\20\0\37\10\2\0\106\10"+
    "\61\0\11\10\2\0\147\10\2\0\4\10\1\0\36\10\2\0\2\10"+
    "\105\0\13\10\1\0\3\10\1\0\4\10\1\0\27\10\35\0\64\10"+
    "\16\0\62\10\34\0\12\11\30\0\6\10\3\0\1\10\4\0\12\11"+
    "\34\10\12\0\27\10\31\0\35\10\7\0\57\10\34\0\1\10\12\11"+
    "\6\0\5\10\1\0\12\10\12\11\5\10\1\0\51\10\27\0\3\10"+
    "\1\0\10\10\4\0\12\11\6\0\27\10\3\0\1\10\3\0\62\10"+
    "\1\0\1\10\3\0\2\10\2\0\5\10\2\0\1\10\1\0\1\10"+
    "\30\0\3\10\2\0\13\10\7\0\3\10\14\0\6\10\2\0\6\10"+
    "\2\0\6\10\11\0\7\10\1\0\7\10\1\0\53\10\1\0\4\10"+
    "\4\0\2\10\132\0\43\10\15\0\12\11\6\0\u2ba4\10\14\0\27\10"+
    "\4\0\61\10\u2104\0\u016e\10\2\0\152\10\46\0\7\10\14\0\5\10"+
    "\5\0\1\10\1\0\12\10\1\0\15\10\1\0\5\10\1\0\1\10"+
    "\1\0\2\10\1\0\2\10\1\0\154\10\41\0\u016b\10\22\0\100\10"+
    "\2\0\66\10\50\0\14\10\164\0\5\10\1\0\207\10\23\0\12\11"+
    "\7\0\32\10\6\0\32\10\13\0\131\10\3\0\6\10\2\0\6\10"+
    "\2\0\6\10\2\0\3\10\43\0\14\10\1\0\32\10\1\0\23\10"+
    "\1\0\2\10\1\0\17\10\2\0\16\10\42\0\173\10\u0185\0\35\10"+
    "\3\0\61\10\57\0\40\10\20\0\21\10\1\0\10\10\6\0\46\10"+
    "\12\0\36\10\2\0\44\10\4\0\10\10\60\0\236\10\2\0\12\11"+
    "\126\0\50\10\10\0\64\10\234\0\u0137\10\11\0\26\10\12\0\10\10"+
    "\230\0\6\10\2\0\1\10\1\0\54\10\1\0\2\10\3\0\1\10"+
    "\2\0\27\10\12\0\27\10\11\0\37\10\141\0\26\10\12\0\32\10"+
    "\106\0\70\10\6\0\2\10\100\0\1\10\17\0\4\10\1\0\3\10"+
    "\1\0\33\10\54\0\35\10\3\0\35\10\43\0\10\10\1\0\34\10"+
    "\33\0\66\10\12\0\26\10\12\0\23\10\15\0\22\10\156\0\111\10"+
    "\u03ba\0\65\10\56\0\12\11\23\0\55\10\40\0\31\10\7\0\12\11"+
    "\11\0\44\10\17\0\12\11\20\0\43\10\3\0\1\10\14\0\60\10"+
    "\16\0\4\10\13\0\12\11\1\10\45\0\22\10\1\0\31\10\204\0"+
    "\57\10\21\0\12\11\13\0\10\10\2\0\2\10\2\0\26\10\1\0"+
    "\7\10\1\0\2\10\1\0\5\10\3\0\1\10\37\0\5\10\u011e\0"+
    "\60\10\24\0\2\10\1\0\1\10\10\0\12\11\246\0\57\10\121\0"+
    "\60\10\24\0\1\10\13\0\12\11\46\0\53\10\25\0\12\11\u01d6\0"+
    "\100\10\12\11\25\0\1\10\u01c0\0\71\10\u0507\0\u0399\10\u0c67\0\u042f\10"+
    "\u33d1\0\u0239\10\7\0\37\10\1\0\12\11\146\0\36\10\22\0\60\10"+
    "\20\0\4\10\14\0\12\11\11\0\25\10\5\0\23\10\u0370\0\105\10"+
    "\13\0\1\10\102\0\15\10\u4060\0\2\10\u0bfe\0\153\10\5\0\15\10"+
    "\3\0\11\10\7\0\12\10\u1766\0\125\10\1\0\107\10\1\0\2\10"+
    "\2\0\1\10\2\0\2\10\2\0\4\10\1\0\14\10\1\0\1\10"+
    "\1\0\7\10\1\0\101\10\1\0\4\10\2\0\10\10\1\0\7\10"+
    "\1\0\34\10\1\0\4\10\1\0\5\10\1\0\1\10\3\0\7\10"+
    "\1\0\u0154\10\2\0\31\10\1\0\31\10\1\0\37\10\1\0\31\10"+
    "\1\0\37\10\1\0\31\10\1\0\37\10\1\0\31\10\1\0\37\10"+
    "\1\0\31\10\1\0\10\10\2\0\62\11\u1000\0\305\10\u053b\0\4\10"+
    "\1\0\33\10\1\0\2\10\1\0\1\10\2\0\1\10\1\0\12\10"+
    "\1\0\4\10\1\0\1\10\1\0\1\10\6\0\1\10\4\0\1\10"+
    "\1\0\1\10\1\0\1\10\1\0\3\10\1\0\2\10\1\0\1\10"+
    "\2\0\1\10\1\0\1\10\1\0\1\10\1\0\1\10\1\0\1\10"+
    "\1\0\2\10\1\0\1\10\2\0\4\10\1\0\7\10\1\0\4\10"+
    "\1\0\4\10\1\0\1\10\1\0\12\10\1\0\21\10\5\0\3\10"+
    "\1\0\5\10\1\0\21\10\u1144\0\ua6d7\10\51\0\u1035\10\13\0\336\10"+
    "\u3fe2\0\u021e\10\uffff\0\uffff\0\uffff\0\uffff\0\uffff\0\uffff\0\uffff\0\uffff\0\uffff\0\uffff\0\uffff\0\uffff\0\uffff\0\uffff\0\u05f0\0";

  /** 
   * Translates characters to character classes
   */
  private static final char [] ZZ_CMAP = zzUnpackCMap(ZZ_CMAP_PACKED);

  /** 
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\1\1\1\0\1\2\1\3\1\4\3\5\1\1\1\6"+
    "\2\7\2\6\1\10\1\11\1\12\1\6\1\2\5\6"+
    "\1\13\6\6\1\14\1\15\1\16\1\17\1\20\1\21"+
    "\1\22\1\23\1\24\1\25\1\26\1\27\1\30\1\31"+
    "\1\32\1\33\1\34\1\2\1\35\1\36\1\37\1\1"+
    "\1\0\1\40\1\41\1\0\1\42\1\43\1\0\1\7"+
    "\1\0\2\6\1\44\1\45\1\46\1\47\1\0\1\50"+
    "\2\6\2\0\20\6\1\51\2\6\1\52\1\53\1\54"+
    "\1\55\1\56\1\57\1\60\1\61\1\62\1\63\1\64"+
    "\1\65\1\66\1\67\1\70\1\0\1\71\4\0\1\72"+
    "\1\73\1\74\1\75\1\0\1\42\1\0\1\7\2\6"+
    "\1\76\2\6\1\77\2\0\1\77\2\0\4\6\1\100"+
    "\4\6\1\101\7\6\1\102\1\6\1\103\1\104\1\105"+
    "\4\0\1\1\2\6\1\106\3\6\4\0\1\6\1\107"+
    "\1\110\4\6\1\111\1\112\5\6\1\113\1\114\1\6"+
    "\1\115\1\116\2\0\1\117\2\6\1\120\1\6\1\0"+
    "\1\121\3\6\1\122\1\6\1\123\4\6\2\0\2\6"+
    "\1\124\1\0\2\6\1\125\1\6\1\126\1\127\1\130"+
    "\1\6\1\131\1\0\1\132\2\6\1\133\1\6\1\134"+
    "\1\0\2\6\1\135\1\0\1\136\1\6\1\0\1\6"+
    "\1\137\1\140";

  private static int [] zzUnpackAction() {
    int [] result = new int[241];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** 
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\110\0\220\0\330\0\u0120\0\220\0\u0168\0\u01b0"+
    "\0\u01b0\0\u01f8\0\u0240\0\u0288\0\u02d0\0\u0318\0\u0360\0\u03a8"+
    "\0\u03f0\0\u0438\0\u0480\0\u04c8\0\u0510\0\u0558\0\u05a0\0\u05e8"+
    "\0\220\0\u0630\0\u0678\0\u06c0\0\u0708\0\u0750\0\u0798\0\u07e0"+
    "\0\u0828\0\u0870\0\u08b8\0\u0900\0\u0948\0\u0990\0\u09d8\0\u0a20"+
    "\0\220\0\220\0\220\0\220\0\220\0\220\0\220\0\220"+
    "\0\u0a68\0\u0ab0\0\u0af8\0\220\0\u0b40\0\u0b88\0\220\0\220"+
    "\0\u0bd0\0\u0c18\0\220\0\u0c60\0\u0ca8\0\u0cf0\0\u0d38\0\u0d80"+
    "\0\220\0\220\0\220\0\220\0\u0dc8\0\u01f8\0\u0e10\0\u0e58"+
    "\0\u0ea0\0\u0ee8\0\u0f30\0\u0f78\0\u0fc0\0\u1008\0\u1050\0\u1098"+
    "\0\u10e0\0\u1128\0\u1170\0\u11b8\0\u1200\0\u1248\0\u1290\0\u12d8"+
    "\0\u1320\0\u1368\0\u13b0\0\u13f8\0\u1440\0\220\0\220\0\u1488"+
    "\0\220\0\220\0\220\0\220\0\220\0\u14d0\0\220\0\u1518"+
    "\0\220\0\220\0\220\0\220\0\u0a68\0\220\0\u1560\0\u15a8"+
    "\0\u15f0\0\u1638\0\220\0\220\0\220\0\220\0\u1680\0\u16c8"+
    "\0\u1710\0\u0cf0\0\u1758\0\u17a0\0\220\0\u17e8\0\u1830\0\220"+
    "\0\u1878\0\u18c0\0\u0ea0\0\u1908\0\u1950\0\u1998\0\u19e0\0\u1a28"+
    "\0\u1a70\0\u01f8\0\u1ab8\0\u1b00\0\u1b48\0\u1b90\0\u01f8\0\u1bd8"+
    "\0\u1c20\0\u1c68\0\u1cb0\0\u1cf8\0\u1d40\0\u1d88\0\u01f8\0\u1dd0"+
    "\0\220\0\220\0\220\0\u1e18\0\u1e60\0\u1ea8\0\u1ef0\0\220"+
    "\0\u1f38\0\u1f80\0\u01f8\0\u1fc8\0\u2010\0\u2058\0\u20a0\0\u20e8"+
    "\0\u2130\0\u2178\0\u21c0\0\u01f8\0\u01f8\0\u2208\0\u2250\0\u2298"+
    "\0\u22e0\0\u01f8\0\u01f8\0\u2328\0\u2370\0\u23b8\0\u2400\0\u2448"+
    "\0\u01f8\0\u01f8\0\u2490\0\220\0\220\0\u24d8\0\u2520\0\u01f8"+
    "\0\u2568\0\u25b0\0\u01f8\0\u25f8\0\u2640\0\u01f8\0\u2688\0\u26d0"+
    "\0\u2718\0\u01f8\0\u2760\0\u01f8\0\u27a8\0\u27f0\0\u2838\0\u2880"+
    "\0\u28c8\0\u2910\0\u2958\0\u29a0\0\u01f8\0\u29e8\0\u2a30\0\u2a78"+
    "\0\u01f8\0\u2ac0\0\u01f8\0\u01f8\0\u01f8\0\u2b08\0\220\0\u2b50"+
    "\0\u01f8\0\u2b98\0\u2be0\0\u01f8\0\u2c28\0\u01f8\0\u2c70\0\u2cb8"+
    "\0\u2d00\0\u01f8\0\u2d48\0\u01f8\0\u2d90\0\u2dd8\0\u2e20\0\220"+
    "\0\u01f8";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[241];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /** 
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpackTrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\1\3\1\4\1\5\1\6\1\7\1\6\1\10\1\11"+
    "\1\12\1\3\1\13\1\14\1\12\1\15\1\13\2\12"+
    "\1\16\1\12\1\17\1\20\1\21\1\22\1\23\1\3"+
    "\3\12\1\24\1\25\1\12\1\26\1\27\1\30\1\31"+
    "\2\12\4\13\1\12\1\32\1\33\1\34\4\12\1\35"+
    "\1\36\1\37\2\12\1\40\1\41\1\42\1\43\1\44"+
    "\1\45\1\46\1\47\1\50\1\51\1\52\1\53\1\54"+
    "\1\55\1\56\1\57\1\60\1\61\3\62\2\0\23\62"+
    "\1\63\11\62\1\64\45\62\111\0\1\65\1\66\71\0"+
    "\1\67\107\0\1\70\16\0\1\6\112\0\2\11\110\0"+
    "\13\12\3\0\1\12\2\0\11\12\1\0\23\12\34\0"+
    "\2\13\2\0\1\13\2\0\2\71\2\0\1\72\1\73"+
    "\16\0\4\13\51\0\1\74\1\75\2\0\1\75\2\76"+
    "\2\71\2\0\1\72\1\73\16\0\4\75\47\0\11\12"+
    "\1\77\1\12\3\0\1\12\2\0\11\12\1\0\23\12"+
    "\32\0\13\12\3\0\1\12\2\0\11\12\1\0\1\12"+
    "\1\100\21\12\45\0\1\101\50\0\1\102\37\0\1\103"+
    "\47\0\1\104\25\0\2\72\2\0\1\72\6\0\1\105"+
    "\17\0\4\72\47\0\13\12\3\0\1\12\2\0\4\12"+
    "\1\106\1\107\3\12\1\0\17\12\1\110\3\12\22\0"+
    "\3\111\1\0\24\111\1\112\57\111\10\0\13\12\3\0"+
    "\1\12\2\0\6\12\1\113\2\12\1\0\1\114\22\12"+
    "\32\0\13\12\3\0\1\12\2\0\1\115\1\12\1\116"+
    "\6\12\1\0\1\117\1\120\21\12\32\0\11\12\1\121"+
    "\1\12\3\0\1\12\2\0\2\12\1\122\6\12\1\0"+
    "\23\12\32\0\13\12\3\0\1\12\2\0\11\12\1\0"+
    "\22\12\1\123\32\0\13\12\3\0\1\12\2\0\2\12"+
    "\1\124\6\12\1\0\23\12\32\0\13\12\3\0\1\12"+
    "\2\0\2\12\1\125\6\12\1\0\1\126\22\12\32\0"+
    "\11\12\1\127\1\12\3\0\1\12\2\0\7\12\1\130"+
    "\1\12\1\0\21\12\1\131\1\12\32\0\13\12\3\0"+
    "\1\12\2\0\11\12\1\0\12\12\1\132\10\12\32\0"+
    "\13\12\3\0\1\12\2\0\11\12\1\0\1\133\22\12"+
    "\32\0\13\12\3\0\1\12\2\0\2\12\1\134\6\12"+
    "\1\0\23\12\32\0\13\12\3\0\1\12\2\0\2\12"+
    "\1\135\6\12\1\0\23\12\116\0\1\136\102\0\1\137"+
    "\1\0\1\140\2\0\1\141\103\0\1\142\3\0\1\143"+
    "\107\0\1\144\37\0\1\145\45\0\1\146\1\0\1\147"+
    "\106\0\1\150\1\151\107\0\1\152\107\0\1\153\107\0"+
    "\1\154\13\0\107\155\1\156\3\62\2\0\23\62\1\0"+
    "\11\62\1\0\45\62\13\0\1\157\2\0\1\157\1\160"+
    "\11\0\1\161\1\162\3\0\1\163\1\164\1\165\1\0"+
    "\1\166\2\0\4\157\37\0\3\65\4\0\101\65\2\66"+
    "\1\167\105\66\12\0\2\170\2\0\1\170\4\0\2\171"+
    "\20\0\4\170\51\0\2\72\2\0\1\72\2\0\2\71"+
    "\3\0\1\73\16\0\4\72\51\0\2\74\2\0\1\74"+
    "\2\0\2\71\2\0\1\72\1\73\16\0\4\74\51\0"+
    "\1\74\1\75\2\0\1\75\2\0\2\71\2\0\1\72"+
    "\1\73\16\0\4\75\51\0\5\172\2\0\2\172\10\0"+
    "\3\172\7\0\4\172\1\0\1\172\1\0\1\172\1\0"+
    "\1\172\41\0\13\12\3\0\1\12\2\0\4\12\1\173"+
    "\4\12\1\0\23\12\32\0\13\12\3\0\1\12\2\0"+
    "\11\12\1\0\10\12\1\174\12\12\47\0\1\175\72\0"+
    "\13\12\3\0\1\12\2\0\7\12\1\176\1\12\1\0"+
    "\23\12\32\0\13\12\3\0\1\12\2\0\11\12\1\0"+
    "\20\12\1\177\2\12\51\0\1\200\73\0\1\201\2\0"+
    "\1\201\1\202\7\0\1\203\1\111\1\204\1\205\10\111"+
    "\2\0\4\201\47\0\11\12\1\206\1\12\3\0\1\12"+
    "\2\0\11\12\1\0\23\12\32\0\13\12\3\0\1\12"+
    "\2\0\11\12\1\0\1\207\22\12\32\0\13\12\3\0"+
    "\1\12\2\0\5\12\1\210\3\12\1\0\23\12\32\0"+
    "\13\12\3\0\1\12\2\0\11\12\1\0\1\12\1\211"+
    "\21\12\32\0\13\12\3\0\1\12\2\0\6\12\1\212"+
    "\2\12\1\0\23\12\32\0\13\12\3\0\1\12\2\0"+
    "\11\12\1\0\1\213\22\12\32\0\13\12\3\0\1\12"+
    "\2\0\7\12\1\214\1\12\1\0\23\12\32\0\13\12"+
    "\3\0\1\12\2\0\5\12\1\215\3\12\1\0\23\12"+
    "\32\0\13\12\3\0\1\12\2\0\11\12\1\0\20\12"+
    "\1\216\2\12\32\0\13\12\3\0\1\12\2\0\6\12"+
    "\1\217\2\12\1\0\23\12\32\0\13\12\3\0\1\12"+
    "\2\0\11\12\1\0\10\12\1\220\12\12\32\0\13\12"+
    "\3\0\1\12\2\0\5\12\1\221\3\12\1\0\23\12"+
    "\32\0\13\12\3\0\1\12\2\0\11\12\1\0\1\12"+
    "\1\222\21\12\32\0\13\12\3\0\1\12\2\0\6\12"+
    "\1\223\2\12\1\0\23\12\32\0\13\12\3\0\1\224"+
    "\2\0\11\12\1\0\23\12\32\0\13\12\3\0\1\12"+
    "\2\0\11\12\1\0\13\12\1\225\7\12\32\0\13\12"+
    "\3\0\1\12\2\0\7\12\1\226\1\12\1\0\23\12"+
    "\32\0\13\12\3\0\1\12\2\0\11\12\1\0\20\12"+
    "\1\227\2\12\32\0\13\12\3\0\1\12\2\0\11\12"+
    "\1\0\7\12\1\230\13\12\116\0\1\231\107\0\1\232"+
    "\107\0\1\233\26\0\1\234\2\0\1\234\26\0\4\234"+
    "\51\0\5\235\2\0\2\235\10\0\3\235\7\0\4\235"+
    "\1\0\1\235\1\0\1\235\1\0\1\235\43\0\5\236"+
    "\2\0\2\236\10\0\3\236\7\0\4\236\1\0\1\236"+
    "\1\0\1\236\1\0\1\236\43\0\5\237\2\0\2\237"+
    "\10\0\3\237\7\0\4\237\1\0\1\237\1\0\1\237"+
    "\1\0\1\237\31\0\1\66\1\240\1\167\105\66\12\0"+
    "\2\170\2\0\1\170\7\0\1\73\16\0\4\170\51\0"+
    "\2\170\2\0\1\170\26\0\4\170\47\0\11\12\1\241"+
    "\1\12\3\0\1\12\2\0\2\12\1\242\6\12\1\0"+
    "\23\12\32\0\11\12\1\243\1\12\3\0\1\12\2\0"+
    "\11\12\1\0\23\12\32\0\11\12\1\244\1\12\3\0"+
    "\1\12\2\0\11\12\1\0\2\12\1\245\20\12\32\0"+
    "\13\12\3\0\1\12\2\0\11\12\1\0\1\246\22\12"+
    "\35\0\1\247\2\0\1\247\26\0\4\247\51\0\5\250"+
    "\2\0\2\250\10\0\3\250\7\0\4\250\1\0\1\250"+
    "\1\0\1\250\1\0\1\250\43\0\5\251\2\0\2\251"+
    "\10\0\3\251\7\0\4\251\1\0\1\251\1\0\1\251"+
    "\1\0\1\251\43\0\5\252\2\0\2\252\10\0\3\252"+
    "\7\0\4\252\1\0\1\252\1\0\1\252\1\0\1\252"+
    "\41\0\13\12\3\0\1\12\2\0\2\12\1\253\6\12"+
    "\1\0\23\12\32\0\13\12\3\0\1\12\2\0\11\12"+
    "\1\0\1\12\1\254\21\12\32\0\13\12\3\0\1\12"+
    "\2\0\11\12\1\0\7\12\1\255\13\12\32\0\13\12"+
    "\3\0\1\12\2\0\11\12\1\0\1\12\1\256\21\12"+
    "\32\0\13\12\3\0\1\12\2\0\2\12\1\257\6\12"+
    "\1\0\23\12\32\0\13\12\3\0\1\12\2\0\1\260"+
    "\10\12\1\0\23\12\32\0\13\12\3\0\1\12\2\0"+
    "\11\12\1\0\16\12\1\261\4\12\32\0\11\12\1\262"+
    "\1\12\3\0\1\12\2\0\11\12\1\0\23\12\32\0"+
    "\11\12\1\263\1\12\3\0\1\12\2\0\11\12\1\0"+
    "\23\12\32\0\13\12\3\0\1\12\2\0\7\12\1\264"+
    "\1\12\1\0\10\12\1\265\12\12\32\0\11\12\1\266"+
    "\1\12\3\0\1\12\2\0\11\12\1\0\23\12\32\0"+
    "\13\12\3\0\1\12\2\0\1\267\10\12\1\0\23\12"+
    "\32\0\13\12\3\0\1\12\2\0\7\12\1\270\1\12"+
    "\1\0\23\12\32\0\13\12\3\0\1\12\2\0\11\12"+
    "\1\0\14\12\1\271\6\12\32\0\13\12\3\0\1\12"+
    "\2\0\11\12\1\0\1\272\22\12\32\0\13\12\3\0"+
    "\1\12\2\0\11\12\1\0\6\12\1\273\14\12\35\0"+
    "\1\274\2\0\1\274\26\0\4\274\51\0\5\275\2\0"+
    "\2\275\10\0\3\275\7\0\4\275\1\0\1\275\1\0"+
    "\1\275\1\0\1\275\43\0\5\276\2\0\2\276\10\0"+
    "\3\276\7\0\4\276\1\0\1\276\1\0\1\276\1\0"+
    "\1\276\43\0\5\277\2\0\2\277\10\0\3\277\7\0"+
    "\4\277\1\0\1\277\1\0\1\277\1\0\1\277\41\0"+
    "\13\12\3\0\1\12\2\0\6\12\1\300\2\12\1\0"+
    "\23\12\32\0\13\12\3\0\1\12\2\0\1\301\10\12"+
    "\1\0\23\12\32\0\13\12\3\0\1\12\2\0\6\12"+
    "\1\302\2\12\1\0\23\12\32\0\13\12\3\0\1\12"+
    "\2\0\11\12\1\0\3\12\1\303\17\12\32\0\13\12"+
    "\3\0\1\12\2\0\6\12\1\304\2\12\1\0\23\12"+
    "\35\0\1\111\2\0\1\111\26\0\4\111\51\0\5\111"+
    "\2\0\2\111\10\0\3\111\7\0\4\111\1\0\1\111"+
    "\1\0\1\111\1\0\1\111\43\0\5\202\2\0\2\202"+
    "\10\0\3\202\7\0\4\202\1\0\1\202\1\0\1\202"+
    "\1\0\1\202\43\0\5\305\2\0\2\305\10\0\3\305"+
    "\7\0\4\305\1\0\1\305\1\0\1\305\1\0\1\305"+
    "\41\0\13\12\3\0\1\12\2\0\11\12\1\0\6\12"+
    "\1\306\14\12\32\0\13\12\3\0\1\12\2\0\7\12"+
    "\1\307\1\12\1\0\23\12\32\0\13\12\3\0\1\12"+
    "\2\0\7\12\1\310\1\12\1\0\23\12\32\0\13\12"+
    "\3\0\1\12\2\0\6\12\1\311\2\12\1\0\23\12"+
    "\32\0\11\12\1\312\1\12\3\0\1\12\2\0\11\12"+
    "\1\0\23\12\32\0\13\12\3\0\1\313\2\0\11\12"+
    "\1\0\23\12\32\0\13\12\3\0\1\12\2\0\7\12"+
    "\1\314\1\12\1\0\23\12\32\0\13\12\3\0\1\12"+
    "\2\0\11\12\1\0\7\12\1\315\13\12\32\0\13\12"+
    "\3\0\1\12\2\0\11\12\1\0\7\12\1\316\13\12"+
    "\32\0\13\12\3\0\1\12\2\0\11\12\1\0\7\12"+
    "\1\317\13\12\32\0\13\12\3\0\1\12\2\0\2\12"+
    "\1\320\6\12\1\0\23\12\34\0\5\321\2\0\2\321"+
    "\10\0\3\321\7\0\4\321\1\0\1\321\1\0\1\321"+
    "\1\0\1\321\43\0\5\322\2\0\2\322\10\0\3\322"+
    "\7\0\4\322\1\0\1\322\1\0\1\322\1\0\1\322"+
    "\41\0\13\12\3\0\1\12\2\0\11\12\1\0\1\12"+
    "\1\323\21\12\32\0\13\12\3\0\1\12\2\0\4\12"+
    "\1\324\4\12\1\0\23\12\32\0\13\12\3\0\1\12"+
    "\2\0\7\12\1\325\1\12\1\0\23\12\34\0\5\326"+
    "\2\0\2\326\10\0\3\326\7\0\4\326\1\0\1\326"+
    "\1\0\1\326\1\0\1\326\41\0\13\12\3\0\1\12"+
    "\2\0\11\12\1\0\15\12\1\327\5\12\32\0\13\12"+
    "\3\0\1\12\2\0\11\12\1\0\4\12\1\330\16\12"+
    "\32\0\13\12\3\0\1\12\2\0\5\12\1\331\3\12"+
    "\1\0\23\12\32\0\13\12\3\0\1\12\2\0\5\12"+
    "\1\332\3\12\1\0\23\12\32\0\13\12\3\0\1\12"+
    "\2\0\7\12\1\333\1\12\1\0\23\12\32\0\13\12"+
    "\3\0\1\12\2\0\7\12\1\334\1\12\1\0\23\12"+
    "\32\0\13\12\3\0\1\12\2\0\11\12\1\0\15\12"+
    "\1\335\5\12\32\0\13\12\3\0\1\12\2\0\11\12"+
    "\1\0\16\12\1\336\4\12\34\0\5\337\2\0\2\337"+
    "\10\0\3\337\7\0\4\337\1\0\1\337\1\0\1\337"+
    "\1\0\1\337\43\0\5\340\2\0\2\340\10\0\3\340"+
    "\7\0\4\340\1\0\1\340\1\0\1\340\1\0\1\340"+
    "\41\0\13\12\3\0\1\12\2\0\7\12\1\341\1\12"+
    "\1\0\23\12\32\0\13\12\3\0\1\12\2\0\2\12"+
    "\1\342\6\12\1\0\23\12\34\0\5\204\2\0\2\204"+
    "\10\0\3\204\7\0\4\204\1\0\1\204\1\0\1\204"+
    "\1\0\1\204\41\0\13\12\3\0\1\12\2\0\6\12"+
    "\1\343\2\12\1\0\23\12\32\0\13\12\3\0\1\12"+
    "\2\0\11\12\1\0\5\12\1\344\15\12\32\0\13\12"+
    "\3\0\1\12\2\0\1\345\10\12\1\0\23\12\32\0"+
    "\11\12\1\346\1\12\3\0\1\12\2\0\11\12\1\0"+
    "\23\12\34\0\5\347\2\0\2\347\10\0\3\347\7\0"+
    "\4\347\1\0\1\347\1\0\1\347\1\0\1\347\41\0"+
    "\13\12\3\0\1\12\2\0\11\12\1\0\7\12\1\350"+
    "\13\12\32\0\13\12\3\0\1\12\2\0\11\12\1\0"+
    "\1\351\22\12\32\0\11\12\1\352\1\12\3\0\1\12"+
    "\2\0\11\12\1\0\23\12\34\0\5\353\2\0\2\353"+
    "\10\0\3\353\7\0\4\353\1\0\1\353\1\0\1\353"+
    "\1\0\1\353\41\0\11\12\1\354\1\12\3\0\1\12"+
    "\2\0\11\12\1\0\23\12\32\0\13\12\3\0\1\12"+
    "\2\0\1\355\10\12\1\0\23\12\34\0\5\356\2\0"+
    "\2\356\10\0\3\356\7\0\4\356\1\0\1\356\1\0"+
    "\1\356\1\0\1\356\41\0\13\12\3\0\1\12\2\0"+
    "\11\12\1\0\16\12\1\357\4\12\34\0\5\360\2\0"+
    "\2\360\10\0\3\360\7\0\4\360\1\0\1\360\1\0"+
    "\1\360\1\0\1\360\41\0\13\12\3\0\1\12\2\0"+
    "\11\12\1\0\15\12\1\361\5\12\22\0";

  private static int [] zzUnpackTrans() {
    int [] result = new int[11880];
    int offset = 0;
    offset = zzUnpackTrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackTrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /* error codes */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  private static final int ZZ_NO_MATCH = 1;
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /* error messages for the codes above */
  private static final String ZZ_ERROR_MSG[] = {
    "Unknown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state <code>aState</code>
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\1\1\1\0\1\11\2\1\1\11\22\1\1\11\17\1"+
    "\10\11\3\1\1\11\1\1\1\0\2\11\1\0\1\1"+
    "\1\11\1\0\1\1\1\0\2\1\4\11\1\0\3\1"+
    "\2\0\23\1\2\11\1\1\5\11\1\1\1\11\1\1"+
    "\4\11\1\0\1\11\4\0\4\11\1\0\1\1\1\0"+
    "\3\1\1\11\2\1\1\11\2\0\1\1\2\0\23\1"+
    "\3\11\4\0\1\11\6\1\4\0\21\1\2\11\2\0"+
    "\5\1\1\0\13\1\2\0\3\1\1\0\10\1\1\11"+
    "\1\0\6\1\1\0\3\1\1\0\2\1\1\0\1\1"+
    "\1\11\1\1";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[241];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** the input device */
  private java.io.Reader zzReader;

  /** the current state of the DFA */
  private int zzState;

  /** the current lexical state */
  private int zzLexicalState = YYINITIAL;

  /** this buffer contains the current text to be matched and is
      the source of the yytext() string */
  private char zzBuffer[] = new char[ZZ_BUFFERSIZE];

  /** the textposition at the last accepting state */
  private int zzMarkedPos;

  /** the current text position in the buffer */
  private int zzCurrentPos;

  /** startRead marks the beginning of the yytext() string in the buffer */
  private int zzStartRead;

  /** endRead marks the last character in the buffer, that has been read
      from input */
  private int zzEndRead;

  /** number of newlines encountered up to the start of the matched text */
  private int yyline;

  /** the number of characters up to the start of the matched text */
  private int yychar;

  /**
   * the number of characters from the last newline up to the start of the 
   * matched text
   */
  private int yycolumn;

  /** 
   * zzAtBOL == true <=> the scanner is currently at the beginning of a line
   */
  private boolean zzAtBOL = true;

  /** zzAtEOF == true <=> the scanner is at the EOF */
  private boolean zzAtEOF;

  /** denotes if the user-EOF-code has already been executed */
  private boolean zzEOFDone;
  
  /** 
   * The number of occupied positions in zzBuffer beyond zzEndRead.
   * When a lead/high surrogate has been read from the input stream
   * into the final zzBuffer position, this will have a value of 1;
   * otherwise, it will have a value of 0.
   */
  private int zzFinalHighSurrogate = 0;

  /* user code: */
	private ComplexSymbolFactory symbolFactory;
    private Symbol ultimoSimbolo;
    private StringBuffer string = new StringBuffer();

    /*
    * Construtor utilizado na chamada do analisador lÃ©xico pelo CUP
    * @param sf instÃ¢ncia da fÃ¡brica de sÃ­mbolos implementada pelo CUP que usaremos
    * @param is instÃ¢ncia do arquivo de entrada em Pasito que serÃ¡ analisado
    */
    public LexicalAnalyzer(ComplexSymbolFactory sf, FileInputStream is) {
        this(new java.io.InputStreamReader(is));
        symbolFactory = sf;
    }
    public LexicalAnalyzer(ComplexSymbolFactory sf, java.io.Reader reader) {
        this(reader);
        symbolFactory = sf;
    }

    /*
    * Método fábricas de símbolos
    * O sémbolo retornado é uma instância de ComplexSymbolFactory, implementada pelo CUP
    */

    public Symbol symbol(String nome, int code) {

    	System.out.println("<" + nome + ", " + yytext() + "> (" + (yyline + 1) + " - " + (yycolumn + 1) + ")");

    	ultimoSimbolo = symbolFactory.newSymbol(nome, code,
                            new Location(yyline+1, yycolumn+1, yychar),
                            new Location(yyline+1, yycolumn+yylength(), yychar+yylength()));
        return ultimoSimbolo;
    }

    public Symbol symbol(String nome, int code, Object value) {
    	
		System.out.println("<" + nome + ", " + value + "> (" + (yyline + 1) + " - " + (yycolumn + 1) + ")");

    	ultimoSimbolo = symbolFactory.newSymbol(nome, code,
                            new Location(yyline+1, yycolumn+1, yychar),
                            new Location(yyline+1, yycolumn+yylength(), yychar+yylength()),
                            value);
        return ultimoSimbolo;
    }



  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  public LexicalAnalyzer(java.io.Reader in) {
    this.zzReader = in;
  }


  /** 
   * Unpacks the compressed character translation table.
   *
   * @param packed   the packed character translation table
   * @return         the unpacked character translation table
   */
  private static char [] zzUnpackCMap(String packed) {
    char [] map = new char[0x110000];
    int i = 0;  /* index in packed string  */
    int j = 0;  /* index in unpacked array */
    while (i < 2514) {
      int  count = packed.charAt(i++);
      char value = packed.charAt(i++);
      do map[j++] = value; while (--count > 0);
    }
    return map;
  }

  private static String zzToPrintable(String str) {
    StringBuilder builder = new StringBuilder();
    for (int n = 0 ; n < str.length() ; ) {
      int ch = str.codePointAt(n);
      int charCount = Character.charCount(ch);
      n += charCount;
      if (ch > 31 && ch < 127) {
        builder.append((char)ch);
      } else if (charCount == 1) {
        builder.append(String.format("\\u%04X", ch));
      } else {
        builder.append(String.format("\\U%06X", ch));
      }
    }
    return builder.toString();
  }


  /**
   * Refills the input buffer.
   *
   * @return      <code>false</code>, iff there was new input.
   * 
   * @exception   java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead-zzStartRead);

      /* translate stored positions */
      zzEndRead-= zzStartRead;
      zzCurrentPos-= zzStartRead;
      zzMarkedPos-= zzStartRead;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate) {
      /* if not: blow it up */
      char newBuffer[] = new char[zzBuffer.length*2];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
    }

    /* fill the buffer with new input */
    int requested = zzBuffer.length - zzEndRead;
    int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

    /* not supposed to occur according to specification of java.io.Reader */
    if (numRead == 0) {
      throw new java.io.IOException("Reader returned 0 characters. See JFlex examples for workaround.");
    }
    if (numRead > 0) {
      zzEndRead += numRead;
      /* If numRead == requested, we might have requested to few chars to
         encode a full Unicode character. We assume that a Reader would
         otherwise never return half characters. */
      if (numRead == requested) {
        if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
          --zzEndRead;
          zzFinalHighSurrogate = 1;
        }
      }
      /* potentially more input available */
      return false;
    }

    /* numRead < 0 ==> end of stream */
    return true;
  }

    
  /**
   * Closes the input stream.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true;            /* indicate end of file */
    zzEndRead = zzStartRead;  /* invalidate buffer    */

    if (zzReader != null)
      zzReader.close();
  }


  /**
   * Resets the scanner to read from a new input stream.
   * Does not close the old reader.
   *
   * All internal variables are reset, the old input stream 
   * <b>cannot</b> be reused (internal buffer is discarded and lost).
   * Lexical state is set to <tt>ZZ_INITIAL</tt>.
   *
   * Internal scan buffer is resized down to its initial length, if it has grown.
   *
   * @param reader   the new input stream 
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzAtBOL  = true;
    zzAtEOF  = false;
    zzEOFDone = false;
    zzEndRead = zzStartRead = 0;
    zzCurrentPos = zzMarkedPos = 0;
    zzFinalHighSurrogate = 0;
    yyline = yychar = yycolumn = 0;
    zzLexicalState = YYINITIAL;
    if (zzBuffer.length > ZZ_BUFFERSIZE)
      zzBuffer = new char[ZZ_BUFFERSIZE];
  }


  /**
   * Returns the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   */
  public final String yytext() {
    return new String( zzBuffer, zzStartRead, zzMarkedPos-zzStartRead );
  }


  /**
   * Returns the character at position <tt>pos</tt> from the 
   * matched text. 
   * 
   * It is equivalent to yytext().charAt(pos), but faster
   *
   * @param pos the position of the character to fetch. 
   *            A value from 0 to yylength()-1.
   *
   * @return the character at position pos
   */
  public final char yycharat(int pos) {
    return zzBuffer[zzStartRead+pos];
  }


  /**
   * Returns the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occured while scanning.
   *
   * In a wellformed scanner (no or only correct usage of 
   * yypushback(int) and a match-all fallback rule) this method 
   * will only be called with things that "Can't Possibly Happen".
   * If this method is called, something is seriously wrong
   * (e.g. a JFlex bug producing a faulty scanner etc.).
   *
   * Usual syntax/scanner level error handling should be done
   * in error fallback rules.
   *
   * @param   errorCode  the code of the errormessage to display
   */
  private void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    }
    catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  } 


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * They will be read again by then next call of the scanning method
   *
   * @param number  the number of characters to be read again.
   *                This number must not be greater than yylength()!
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }


  /**
   * Contains user EOF-code, which will be executed exactly once,
   * when the end of file is reached
   */
  private void zzDoEOF() throws java.io.IOException {
    if (!zzEOFDone) {
      zzEOFDone = true;
      yyclose();
    }
  }


  /**
   * Resumes scanning until the next regular expression is matched,
   * the end of input is encountered or an I/O-Error occurs.
   *
   * @return      the next token
   * @exception   java.io.IOException  if any I/O-Error occurs
   */
  public java_cup.runtime.Symbol next_token() throws java.io.IOException {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char [] zzBufferL = zzBuffer;
    char [] zzCMapL = ZZ_CMAP;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      yychar+= zzMarkedPosL-zzStartRead;

      boolean zzR = false;
      int zzCh;
      int zzCharCount;
      for (zzCurrentPosL = zzStartRead  ;
           zzCurrentPosL < zzMarkedPosL ;
           zzCurrentPosL += zzCharCount ) {
        zzCh = Character.codePointAt(zzBufferL, zzCurrentPosL, zzMarkedPosL);
        zzCharCount = Character.charCount(zzCh);
        switch (zzCh) {
        case '\u000B':
        case '\u000C':
        case '\u0085':
        case '\u2028':
        case '\u2029':
          yyline++;
          yycolumn = 0;
          zzR = false;
          break;
        case '\r':
          yyline++;
          yycolumn = 0;
          zzR = true;
          break;
        case '\n':
          if (zzR)
            zzR = false;
          else {
            yyline++;
            yycolumn = 0;
          }
          break;
        default:
          zzR = false;
          yycolumn += zzCharCount;
        }
      }

      if (zzR) {
        // peek one character ahead if it is \n (if we have counted one line too much)
        boolean zzPeek;
        if (zzMarkedPosL < zzEndReadL)
          zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        else if (zzAtEOF)
          zzPeek = false;
        else {
          boolean eof = zzRefill();
          zzEndReadL = zzEndRead;
          zzMarkedPosL = zzMarkedPos;
          zzBufferL = zzBuffer;
          if (eof) 
            zzPeek = false;
          else 
            zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        }
        if (zzPeek) yyline--;
      }
      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;
  
      zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


      zzForAction: {
        while (true) {
    
          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMapL[zzInput] ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
        zzAtEOF = true;
            zzDoEOF();
          { 	//System.exit(0); //Armengo para evitar loop infinito
  return symbol("EOF",EOF);
 }
      }
      else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [180] {  }");
            { 
            }
          case 97: break;
          case 2: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [286] { System.out.println("+ZZ_NL+"\t\t\t\t\t\t\"Scanner warning >> \" +"+ZZ_NL+"\t\t\t\t\t\t\"Unrecognized character \'\" + yytext() + \"\' -- ignored\" + \" at line\" +"+ZZ_NL+"                \t\t(yyline+1) + \", column \" + (yycolumn+1) ); }");
            { System.out.println(
						"Scanner warning >> " +
						"Unrecognized character '" + yytext() + "' -- ignored" + " at line" +
                		(yyline+1) + ", column " + (yycolumn+1) );
            }
          case 98: break;
          case 3: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [221] { return symbol(\"DIV\", DIV); }");
            { return symbol("DIV", DIV);
            }
          case 99: break;
          case 4: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [220] { return symbol(\"TIMES\", TIMES); }");
            { return symbol("TIMES", TIMES);
            }
          case 100: break;
          case 5: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [152] { if( ultimoSimbolo != null )"+ZZ_NL+"\t\t\t\t\t\t\tif (\tultimoSimbolo.sym == ID ||"+ZZ_NL+"\t\t\t\t\t\t   \t\t\tultimoSimbolo.sym == INT ||"+ZZ_NL+"\t\t\t\t\t\t\t\t\tultimoSimbolo.sym == INT8 ||"+ZZ_NL+"\t\t\t\t\t\t   \t\t\tultimoSimbolo.sym == INT16 ||"+ZZ_NL+"\t\t\t\t\t\t   \t\t\tultimoSimbolo.sym == INT32 ||"+ZZ_NL+"\t\t\t\t\t\t\t\t\tultimoSimbolo.sym == INT64 ||"+ZZ_NL+"\t\t\t\t\t\t\t\t\tultimoSimbolo.sym == FLOAT ||"+ZZ_NL+"\t\t\t\t\t\t\t\t\tultimoSimbolo.sym == FLOAT32 ||"+ZZ_NL+"\t\t\t\t\t\t\t\t\tultimoSimbolo.sym == FLOAT64 ||"+ZZ_NL+"\t\t\t\t\t\t\t\t\tultimoSimbolo.sym == COMPLEX ||"+ZZ_NL+"\t\t\t\t\t\t\t\t\tultimoSimbolo.sym == COMPLEX64 ||"+ZZ_NL+"\t\t\t\t\t\t\t\t\tultimoSimbolo.sym == COMPLEX128 ||"+ZZ_NL+"\t\t\t\t\t\t\t\t\tultimoSimbolo.sym == RUNE_LIT ||"+ZZ_NL+"\t\t\t\t\t\t\t\t\tultimoSimbolo.sym == STRING_LIT ||"+ZZ_NL+"\t\t\t\t\t\t\t\t\tultimoSimbolo.sym == BREAK ||"+ZZ_NL+"\t\t\t\t\t\t\t\t\tultimoSimbolo.sym == CONTINUE ||"+ZZ_NL+"\t\t\t\t\t\t\t\t\tultimoSimbolo.sym == FALLTHROUGH ||"+ZZ_NL+"\t\t\t\t\t\t\t\t\tultimoSimbolo.sym == RETURN ||"+ZZ_NL+"\t\t\t\t\t\t\t\t\tultimoSimbolo.sym == INC_OP ||"+ZZ_NL+"\t\t\t\t\t\t\t\t\tultimoSimbolo.sym == DEC_OP ||"+ZZ_NL+"\t\t\t\t\t\t\t\t\tultimoSimbolo.sym == RPAR ||"+ZZ_NL+"\t\t\t\t\t\t\t\t\tultimoSimbolo.sym == RSBRACK ||"+ZZ_NL+"\t\t\t\t\t\t\t\t\tultimoSimbolo.sym == RBRACK "+ZZ_NL+"\t\t\t\t\t\t\t\t)"+ZZ_NL+"\t\t\t\t\t  return symbol(\"SEMICOLON\", SEMICOLON); }");
            { if( ultimoSimbolo != null )
							if (	ultimoSimbolo.sym == ID ||
						   			ultimoSimbolo.sym == INT ||
									ultimoSimbolo.sym == INT8 ||
						   			ultimoSimbolo.sym == INT16 ||
						   			ultimoSimbolo.sym == INT32 ||
									ultimoSimbolo.sym == INT64 ||
									ultimoSimbolo.sym == FLOAT ||
									ultimoSimbolo.sym == FLOAT32 ||
									ultimoSimbolo.sym == FLOAT64 ||
									ultimoSimbolo.sym == COMPLEX ||
									ultimoSimbolo.sym == COMPLEX64 ||
									ultimoSimbolo.sym == COMPLEX128 ||
									ultimoSimbolo.sym == RUNE_LIT ||
									ultimoSimbolo.sym == STRING_LIT ||
									ultimoSimbolo.sym == BREAK ||
									ultimoSimbolo.sym == CONTINUE ||
									ultimoSimbolo.sym == FALLTHROUGH ||
									ultimoSimbolo.sym == RETURN ||
									ultimoSimbolo.sym == INC_OP ||
									ultimoSimbolo.sym == DEC_OP ||
									ultimoSimbolo.sym == RPAR ||
									ultimoSimbolo.sym == RSBRACK ||
									ultimoSimbolo.sym == RBRACK 
								)
					  return symbol("SEMICOLON", SEMICOLON);
            }
          case 101: break;
          case 6: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [283] { return symbol(\"ID\", ID, yytext()); }");
            { return symbol("ID", ID, yytext());
            }
          case 102: break;
          case 7: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [213] { return symbol(\"INT\", INT, Integer.parseInt(yytext())); }");
            { return symbol("INT", INT, Integer.parseInt(yytext()));
            }
          case 103: break;
          case 8: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [218] { return symbol(\"PLUS\", PLUS); }");
            { return symbol("PLUS", PLUS);
            }
          case 104: break;
          case 9: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [219] { return symbol(\"MINUS\", MINUS); }");
            { return symbol("MINUS", MINUS);
            }
          case 105: break;
          case 10: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [264] { return symbol(\"DOT\", DOT); }");
            { return symbol("DOT", DOT);
            }
          case 106: break;
          case 11: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [273] { string.setLength(0); yybegin(INTERPRETED_STRING); }");
            { string.setLength(0); yybegin(INTERPRETED_STRING);
            }
          case 107: break;
          case 12: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [222] { return symbol(\"REMAINDER\", REMAINDER); }");
            { return symbol("REMAINDER", REMAINDER);
            }
          case 108: break;
          case 13: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [223] { return symbol(\"BITAND\", BITAND); }");
            { return symbol("BITAND", BITAND);
            }
          case 109: break;
          case 14: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [224] { return symbol(\"BITOR\", BITOR); }");
            { return symbol("BITOR", BITOR);
            }
          case 110: break;
          case 15: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [225] { return symbol(\"BITXOR\", BITXOR); }");
            { return symbol("BITXOR", BITXOR);
            }
          case 111: break;
          case 16: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [250] { return symbol(\"LT\", LT); }");
            { return symbol("LT", LT);
            }
          case 112: break;
          case 17: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [251] { return symbol(\"GT\", GT); }");
            { return symbol("GT", GT);
            }
          case 113: break;
          case 18: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [252] { return symbol(\"ASSIGN\", ASSIGN); }");
            { return symbol("ASSIGN", ASSIGN);
            }
          case 114: break;
          case 19: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [253] { return symbol(\"NOT\", NOT); }");
            { return symbol("NOT", NOT);
            }
          case 115: break;
          case 20: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [270] { return symbol(\"COLON\", COLON); }");
            { return symbol("COLON", COLON);
            }
          case 116: break;
          case 21: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [260] { return symbol(\"LPAR\", LPAR); }");
            { return symbol("LPAR", LPAR);
            }
          case 117: break;
          case 22: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [261] { return symbol(\"LSBRACK\", LSBRACK); }");
            { return symbol("LSBRACK", LSBRACK);
            }
          case 118: break;
          case 23: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [262] { return symbol(\"LBRACK\", LBRACK); }");
            { return symbol("LBRACK", LBRACK);
            }
          case 119: break;
          case 24: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [263] { return symbol(\"COMMA\", COMMA); }");
            { return symbol("COMMA", COMMA);
            }
          case 120: break;
          case 25: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [266] { return symbol(\"RPAR\", RPAR); }");
            { return symbol("RPAR", RPAR);
            }
          case 121: break;
          case 26: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [267] { return symbol(\"RSBRACK\", RSBRACK); }");
            { return symbol("RSBRACK", RSBRACK);
            }
          case 122: break;
          case 27: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [268] { return symbol(\"RBRACK\", RBRACK); }");
            { return symbol("RBRACK", RBRACK);
            }
          case 123: break;
          case 28: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [269] { return symbol(\"SEMICOLON\", SEMICOLON); }");
            { return symbol("SEMICOLON", SEMICOLON);
            }
          case 124: break;
          case 29: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [296] { string.append( yytext() ); }");
            { string.append( yytext() );
            }
          case 125: break;
          case 30: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [301] { string.append(\'\\\\\'); }");
            { string.append('\\');
            }
          case 126: break;
          case 31: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [295] { yybegin(YYINITIAL); return symbol(\"INTERPRETED_STRING\", STRING_LIT, string.toString()); }");
            { yybegin(YYINITIAL); return symbol("INTERPRETED_STRING", STRING_LIT, string.toString());
            }
          case 127: break;
          case 32: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [233] { return symbol(\"DIV_ASSIGN\", DIV_ASSIGN); }");
            { return symbol("DIV_ASSIGN", DIV_ASSIGN);
            }
          case 128: break;
          case 33: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [232] { return symbol(\"TIMES_ASSIGN\", TIMES_ASSIGN); }");
            { return symbol("TIMES_ASSIGN", TIMES_ASSIGN);
            }
          case 129: break;
          case 34: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [214] { return symbol(\"FLOAT\", FLOAT, Float.parseFloat(yytext())); }");
            { return symbol("FLOAT", FLOAT, Float.parseFloat(yytext()));
            }
          case 130: break;
          case 35: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [215] { return symbol(\"IMAGINARY\", IMAGINARY, (new ComplexFormat()).parse(yytext())); }");
            { return symbol("IMAGINARY", IMAGINARY, (new ComplexFormat()).parse(yytext()));
            }
          case 131: break;
          case 36: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [246] { return  symbol(\"INC_OP\", INC_OP); }");
            { return  symbol("INC_OP", INC_OP);
            }
          case 132: break;
          case 37: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [230] { return symbol(\"PLUS_ASSIGN\", PLUS_ASSIGN); }");
            { return symbol("PLUS_ASSIGN", PLUS_ASSIGN);
            }
          case 133: break;
          case 38: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [247] { return  symbol(\"DEC_OP\", DEC_OP); }");
            { return  symbol("DEC_OP", DEC_OP);
            }
          case 134: break;
          case 39: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [231] { return symbol(\"MINUS_ASSIGN\", MINUS_ASSIGN); }");
            { return symbol("MINUS_ASSIGN", MINUS_ASSIGN);
            }
          case 135: break;
          case 40: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [200] { return symbol(\"IF\", IF); }");
            { return symbol("IF", IF);
            }
          case 136: break;
          case 41: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [198] { return symbol(\"GO\", GO); }");
            { return symbol("GO", GO);
            }
          case 137: break;
          case 42: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [234] { return symbol(\"REMAINDER_ASSIGN\", REMAINDER_ASSIGN); }");
            { return symbol("REMAINDER_ASSIGN", REMAINDER_ASSIGN);
            }
          case 138: break;
          case 43: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [242] { return symbol(\"AND\", AND); }");
            { return symbol("AND", AND);
            }
          case 139: break;
          case 44: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [228] { return symbol(\"BITCLEAR\", BITCLEAR); }");
            { return symbol("BITCLEAR", BITCLEAR);
            }
          case 140: break;
          case 45: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [235] { return symbol(\"BITAND_ASSIGN\", BITAND_ASSIGN); }");
            { return symbol("BITAND_ASSIGN", BITAND_ASSIGN);
            }
          case 141: break;
          case 46: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [243] { return symbol(\"OR\", OR); }");
            { return symbol("OR", OR);
            }
          case 142: break;
          case 47: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [236] { return symbol(\"BITOR_ASSIGN\", BITOR_ASSIGN); }");
            { return symbol("BITOR_ASSIGN", BITOR_ASSIGN);
            }
          case 143: break;
          case 48: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [237] { return symbol(\"BITXOR_ASSIGN\", BITXOR_ASSIGN); }");
            { return symbol("BITXOR_ASSIGN", BITXOR_ASSIGN);
            }
          case 144: break;
          case 49: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [244] { return symbol(\"CHAN_OP\", CHAN_OP); }");
            { return symbol("CHAN_OP", CHAN_OP);
            }
          case 145: break;
          case 50: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [226] { return symbol(\"LSHIFT\", LSHIFT); }");
            { return symbol("LSHIFT", LSHIFT);
            }
          case 146: break;
          case 51: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [256] { return symbol(\"LEQ\", LEQ); }");
            { return symbol("LEQ", LEQ);
            }
          case 147: break;
          case 52: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [227] { return symbol(\"RSHIFT\", RSHIFT); }");
            { return symbol("RSHIFT", RSHIFT);
            }
          case 148: break;
          case 53: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [257] { return symbol(\"GEQ\", GEQ); }");
            { return symbol("GEQ", GEQ);
            }
          case 149: break;
          case 54: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [249] { return symbol(\"EQ\", EQ); }");
            { return symbol("EQ", EQ);
            }
          case 150: break;
          case 55: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [255] { return symbol(\"NOTEQ\", NOTEQ); }");
            { return symbol("NOTEQ", NOTEQ);
            }
          case 151: break;
          case 56: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [258] { return symbol(\"DASSIGN\", DASSIGN); }");
            { return symbol("DASSIGN", DASSIGN);
            }
          case 152: break;
          case 57: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [275] { /* Tratamento de Raw Strings */"+ZZ_NL+"\t\t              string.append( yytext() );\t"+ZZ_NL+"\t\t\t\t\t  return symbol(\"RAW_STRING\", STRING_LIT, string.toString().replace(\"`\", \"\")); }");
            { /* Tratamento de Raw Strings */
		              string.append( yytext() );	
					  return symbol("RAW_STRING", STRING_LIT, string.toString().replace("`", ""));
            }
          case 153: break;
          case 58: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [298] { string.append(\'\\n\'); }");
            { string.append('\n');
            }
          case 154: break;
          case 59: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [299] { string.append(\'\\r\'); }");
            { string.append('\r');
            }
          case 155: break;
          case 60: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [297] { string.append(\'\\t\'); }");
            { string.append('\t');
            }
          case 156: break;
          case 61: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [300] { string.append(\'\\\"\'); }");
            { string.append('\"');
            }
          case 157: break;
          case 62: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [259] { return symbol(\"DOTDOTDOT\", DOTDOTDOT); }");
            { return symbol("DOTDOTDOT", DOTDOTDOT);
            }
          case 158: break;
          case 63: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [280] { return symbol(\"RUNE\", RUNE_LIT); }");
            { return symbol("RUNE", RUNE_LIT);
            }
          case 159: break;
          case 64: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [196] { return symbol(\"FOR\", FOR); }");
            { return symbol("FOR", FOR);
            }
          case 160: break;
          case 65: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [211] { return symbol(\"VAR\", VAR); }");
            { return symbol("VAR", VAR);
            }
          case 161: break;
          case 66: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [203] { return symbol(\"MAP\", MAP); }");
            { return symbol("MAP", MAP);
            }
          case 162: break;
          case 67: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [238] { return symbol(\"BITCLEAR_ASSIGN\", BITCLEAR_ASSIGN); }");
            { return symbol("BITCLEAR_ASSIGN", BITCLEAR_ASSIGN);
            }
          case 163: break;
          case 68: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [239] { return symbol(\"LSHIFT_ASSIGN\", LSHIFT_ASSIGN); }");
            { return symbol("LSHIFT_ASSIGN", LSHIFT_ASSIGN);
            }
          case 164: break;
          case 69: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [240] { return symbol(\"RSHIFT_ASSIGN\", RSHIFT_ASSIGN); }");
            { return symbol("RSHIFT_ASSIGN", RSHIFT_ASSIGN);
            }
          case 165: break;
          case 70: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [194] { return symbol(\"ELSE\", ELSE); }");
            { return symbol("ELSE", ELSE);
            }
          case 166: break;
          case 71: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [183] { return symbol(\"BOOLEAN\", BOOLEAN); }");
            { return symbol("BOOLEAN", BOOLEAN);
            }
          case 167: break;
          case 72: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [197] { return symbol(\"FUNC\", FUNC); }");
            { return symbol("FUNC", FUNC);
            }
          case 168: break;
          case 73: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [210] { return symbol(\"TYPE\", TYPE); }");
            { return symbol("TYPE", TYPE);
            }
          case 169: break;
          case 74: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [188] { return symbol(\"CASE\", CASE); }");
            { return symbol("CASE", CASE);
            }
          case 170: break;
          case 75: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [189] { return symbol(\"CHAN\", CHAN); }");
            { return symbol("CHAN", CHAN);
            }
          case 171: break;
          case 76: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [199] { return symbol(\"GOTO\", GOTO); }");
            { return symbol("GOTO", GOTO);
            }
          case 172: break;
          case 77: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [303] { int code = Integer.parseInt((yytext().substring(1,4)), 8); string.append(Character.toChars(code)); }");
            { int code = Integer.parseInt((yytext().substring(1,4)), 8); string.append(Character.toChars(code));
            }
          case 173: break;
          case 78: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [302] { int code = Integer.parseInt((yytext().substring(2,4)), 16); string.append(Character.toChars(code)); }");
            { int code = Integer.parseInt((yytext().substring(2,4)), 16); string.append(Character.toChars(code));
            }
          case 174: break;
          case 79: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [193] { return symbol(\"DEFER\", DEFER); }");
            { return symbol("DEFER", DEFER);
            }
          case 175: break;
          case 80: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [184] { return symbol(\"INT32\", INT32); }");
            { return symbol("INT32", INT32);
            }
          case 176: break;
          case 81: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [187] { return symbol(\"BREAK\", BREAK); }");
            { return symbol("BREAK", BREAK);
            }
          case 177: break;
          case 82: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [205] { return symbol(\"RANGE\", RANGE); }");
            { return symbol("RANGE", RANGE);
            }
          case 178: break;
          case 83: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [190] { return symbol(\"CONST\", CONST); }");
            { return symbol("CONST", CONST);
            }
          case 179: break;
          case 84: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [201] { return symbol(\"IMPORT\", IMPORT); }");
            { return symbol("IMPORT", IMPORT);
            }
          case 180: break;
          case 85: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [206] { return symbol(\"RETURN\", RETURN); }");
            { return symbol("RETURN", RETURN);
            }
          case 181: break;
          case 86: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [207] { return symbol(\"SELECT\", SELECT); }");
            { return symbol("SELECT", SELECT);
            }
          case 182: break;
          case 87: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [208] { return symbol(\"STRUCT\", STRUCT); }");
            { return symbol("STRUCT", STRUCT);
            }
          case 183: break;
          case 88: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [209] { return symbol(\"SWITCH\", SWITCH); }");
            { return symbol("SWITCH", SWITCH);
            }
          case 184: break;
          case 89: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [304] { int code = Integer.parseInt((yytext().substring(2,6)), 16); string.append(Character.toChars(code)); }");
            { int code = Integer.parseInt((yytext().substring(2,6)), 16); string.append(Character.toChars(code));
            }
          case 185: break;
          case 90: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [192] { return symbol(\"DEFAULT\", DEFAULT); }");
            { return symbol("DEFAULT", DEFAULT);
            }
          case 186: break;
          case 91: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [185] { return symbol(\"FLOAT64\", FLOAT64); }");
            { return symbol("FLOAT64", FLOAT64);
            }
          case 187: break;
          case 92: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [204] { return symbol(\"PACKAGE\", PACKAGE); }");
            { return symbol("PACKAGE", PACKAGE);
            }
          case 188: break;
          case 93: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [191] { return symbol(\"CONTINUE\", CONTINUE); }");
            { return symbol("CONTINUE", CONTINUE);
            }
          case 189: break;
          case 94: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [202] { return symbol(\"INTERFACE\", INTERFACE); }");
            { return symbol("INTERFACE", INTERFACE);
            }
          case 190: break;
          case 95: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [305] { int code = Integer.parseInt((yytext().substring(2,10)), 16); string.append(Character.toChars(code)); }");
            { int code = Integer.parseInt((yytext().substring(2,10)), 16); string.append(Character.toChars(code));
            }
          case 191: break;
          case 96: 
            System.out.println("line: "+(yyline+1)+" "+"col: "+(yycolumn+1)+" "+"match: --"+zzToPrintable(yytext())+"--");
            System.out.println("action [195] { return symbol(\"FALLTHROUGH\", FALLTHROUGH); }");
            { return symbol("FALLTHROUGH", FALLTHROUGH);
            }
          case 192: break;
          default:
            zzScanError(ZZ_NO_MATCH);
        }
      }
    }
  }

  /**
   * Runs the scanner on input files.
   *
   * This main method is the debugging routine for the scanner.
   * It prints debugging information about each returned token to
   * System.out until the end of file is reached, or an error occured.
   *
   * @param argv   the command line, contains the filenames to run
   *               the scanner on.
   */
  public static void main(String argv[]) {
    if (argv.length == 0) {
      System.out.println("Usage : java LexicalAnalyzer [ --encoding <name> ] <inputfile(s)>");
    }
    else {
      int firstFilePos = 0;
      String encodingName = "UTF-8";
      if (argv[0].equals("--encoding")) {
        firstFilePos = 2;
        encodingName = argv[1];
        try {
          java.nio.charset.Charset.forName(encodingName); // Side-effect: is encodingName valid? 
        } catch (Exception e) {
          System.out.println("Invalid encoding '" + encodingName + "'");
          return;
        }
      }
      for (int i = firstFilePos; i < argv.length; i++) {
        LexicalAnalyzer scanner = null;
        try {
          java.io.FileInputStream stream = new java.io.FileInputStream(argv[i]);
          java.io.Reader reader = new java.io.InputStreamReader(stream, encodingName);
          scanner = new LexicalAnalyzer(reader);
          do {
            System.out.println(scanner.next_token());
          } while (!scanner.zzAtEOF);

        }
        catch (java.io.FileNotFoundException e) {
          System.out.println("File not found : \""+argv[i]+"\"");
        }
        catch (java.io.IOException e) {
          System.out.println("IO error scanning file \""+argv[i]+"\"");
          System.out.println(e);
        }
        catch (Exception e) {
          System.out.println("Unexpected exception:");
          e.printStackTrace();
        }
      }
    }
  }


}
